diff --git a/src/main/java/net/minecraft/core/net/packet/Packet100OpenWindow.java b/src/main/java/net/minecraft/core/net/packet/ContainerOpenPacket.java
similarity index 65%
rename from src/main/java/net/minecraft/core/net/packet/Packet100OpenWindow.java
rename to src/main/java/net/minecraft/core/net/packet/ContainerOpenPacket.java
index 62e1d5da7..2b585519f 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet100OpenWindow.java
+++ b/src/main/java/net/minecraft/core/net/packet/ContainerOpenPacket.java
@@ -1,20 +1,20 @@
 package net.minecraft.core.net.packet;
 
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 
 import java.io.*;
 
 // Referenced classes of package net.minecraft.src:
-//            Packet, NetHandler
+//            Packet, PacketHandler
 
-public class Packet100OpenWindow extends Packet
+public class ContainerOpenPacket extends Packet
 {
 
-    public Packet100OpenWindow()
+    public ContainerOpenPacket()
     {
     }
     
-    public Packet100OpenWindow(int i, int j, String s, int k)
+    public ContainerOpenPacket(int i, int j, String s, int k)
     {
         windowId = i;
         inventoryType = j;
@@ -23,13 +23,13 @@ public class Packet100OpenWindow extends Packet
     }
 
     @Override
-	public void processPacket(NetHandler netHandler)
+	public void handlePacket(PacketHandler packetHandler)
     {
-        netHandler.handleOpenWindow(this);
+        packetHandler.handleOpenWindow(this);
     }
 
     @Override
-	public void readPacketData(DataInputStream dis)
+	public void read(DataInputStream dis)
         throws IOException
     {
         windowId = dis.readByte();
@@ -39,7 +39,7 @@ public class Packet100OpenWindow extends Packet
     }
 
     @Override
-	public void writePacketData(DataOutputStream dos)
+	public void write(DataOutputStream dos)
         throws IOException
     {
         dos.writeByte(windowId);
@@ -49,7 +49,7 @@ public class Packet100OpenWindow extends Packet
     }
 
     @Override
-	public int getPacketSize()
+	public int getEstimatedSize()
     {
         return 3 + windowTitle.length();
     }
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet104WindowItems.java b/src/main/java/net/minecraft/core/net/packet/ContainerSetContentPacket.java
similarity index 82%
rename from src/main/java/net/minecraft/core/net/packet/Packet104WindowItems.java
rename to src/main/java/net/minecraft/core/net/packet/ContainerSetContentPacket.java
index f329755fa..67ad7c452 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet104WindowItems.java
+++ b/src/main/java/net/minecraft/core/net/packet/ContainerSetContentPacket.java
@@ -3,25 +3,25 @@ package net.minecraft.core.net.packet;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 
 import java.io.*;
 import java.util.List;
 
 // Referenced classes of package net.minecraft.src:
-//            Packet, ItemStack, NetHandler
+//            Packet, ItemStack, PacketHandler
 
-public class Packet104WindowItems extends Packet
+public class ContainerSetContentPacket extends Packet
 {
     public int windowId;
     public ItemStack[] stackList;
 
 
-    public Packet104WindowItems()
+    public ContainerSetContentPacket()
     {
     }
 
-    public Packet104WindowItems(int i, List<ItemStack> list)
+    public ContainerSetContentPacket(int i, List<ItemStack> list)
     {
         windowId = i;
         stackList = new ItemStack[list.size()];
@@ -34,7 +34,7 @@ public class Packet104WindowItems extends Packet
     }
 
     @Override
-	public void readPacketData(DataInputStream dis)
+	public void read(DataInputStream dis)
         throws IOException
     {
         windowId = dis.readByte();
@@ -57,7 +57,7 @@ public class Packet104WindowItems extends Packet
     }
 
     @Override
-	public void writePacketData(DataOutputStream dos)
+	public void write(DataOutputStream dos)
         throws IOException
     {
         dos.writeByte(windowId);
@@ -81,13 +81,13 @@ public class Packet104WindowItems extends Packet
     }
 
     @Override
-	public void processPacket(NetHandler netHandler)
+	public void handlePacket(PacketHandler packetHandler)
     {
-        netHandler.handleWindowItems(this);
+        packetHandler.handleWindowItems(this);
     }
 
     @Override
-	public int getPacketSize()
+	public int getEstimatedSize()
     {
         return 3 + stackList.length * 5;
     }
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet105UpdateProgressbar.java b/src/main/java/net/minecraft/core/net/packet/ContainerSetDataPacket.java
similarity index 60%
rename from src/main/java/net/minecraft/core/net/packet/Packet105UpdateProgressbar.java
rename to src/main/java/net/minecraft/core/net/packet/ContainerSetDataPacket.java
index 42c07fb03..f2fcccc86 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet105UpdateProgressbar.java
+++ b/src/main/java/net/minecraft/core/net/packet/ContainerSetDataPacket.java
@@ -1,20 +1,20 @@
 package net.minecraft.core.net.packet;
 
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 
 import java.io.*;
 
 // Referenced classes of package net.minecraft.src:
-//            Packet, NetHandler
+//            Packet, PacketHandler
 
-public class Packet105UpdateProgressbar extends Packet
+public class ContainerSetDataPacket extends Packet
 {
 
-    public Packet105UpdateProgressbar()
+    public ContainerSetDataPacket()
     {
     }
 
-    public Packet105UpdateProgressbar(int windowId, int progressBar, int progressBarValue)
+    public ContainerSetDataPacket(int windowId, int progressBar, int progressBarValue)
     {
         this.windowId = windowId;
         this.progressBar = progressBar;
@@ -22,13 +22,13 @@ public class Packet105UpdateProgressbar extends Packet
     }
     
     @Override
-	public void processPacket(NetHandler netHandler)
+	public void handlePacket(PacketHandler packetHandler)
     {
-        netHandler.handleUpdateProgressbar(this);
+        packetHandler.handleUpdateProgressbar(this);
     }
 
     @Override
-	public void readPacketData(DataInputStream dis)
+	public void read(DataInputStream dis)
         throws IOException
     {
         windowId = dis.readByte();
@@ -37,7 +37,7 @@ public class Packet105UpdateProgressbar extends Packet
     }
 
     @Override
-	public void writePacketData(DataOutputStream dos)
+	public void write(DataOutputStream dos)
         throws IOException
     {
         dos.writeByte(windowId);
@@ -46,7 +46,7 @@ public class Packet105UpdateProgressbar extends Packet
     }
 
     @Override
-	public int getPacketSize()
+	public int getEstimatedSize()
     {
         return 7;
     }
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet103SetSlot.java b/src/main/java/net/minecraft/core/net/packet/ContainerSetSlotPacket.java
similarity index 75%
rename from src/main/java/net/minecraft/core/net/packet/Packet103SetSlot.java
rename to src/main/java/net/minecraft/core/net/packet/ContainerSetSlotPacket.java
index 938335573..d32a79e9b 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet103SetSlot.java
+++ b/src/main/java/net/minecraft/core/net/packet/ContainerSetSlotPacket.java
@@ -2,27 +2,27 @@ package net.minecraft.core.net.packet;
 
 import net.minecraft.core.item.ItemStack;
 import com.mojang.nbt.CompoundTag;
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 
 import java.io.*;
 
 // Referenced classes of package net.minecraft.src:
-//            Packet, NetHandler, ItemStack
+//            Packet, PacketHandler, ItemStack
 
-public class Packet103SetSlot extends Packet
+public class ContainerSetSlotPacket extends Packet
 {
 
-    public Packet103SetSlot()
+    public ContainerSetSlotPacket()
     {
     }
 
     @Override
-	public void processPacket(NetHandler netHandler)
+	public void handlePacket(PacketHandler packetHandler)
     {
-        netHandler.handleSetSlot(this);
+        packetHandler.handleSetSlot(this);
     }
     
-    public Packet103SetSlot(int i, int j, ItemStack itemstack)
+    public ContainerSetSlotPacket(int i, int j, ItemStack itemstack)
     {
         windowId = i;
         itemSlot = j;
@@ -30,7 +30,7 @@ public class Packet103SetSlot extends Packet
     }
 
     @Override
-	public void readPacketData(DataInputStream dis)
+	public void read(DataInputStream dis)
         throws IOException
     {
         windowId = dis.readByte();
@@ -49,7 +49,7 @@ public class Packet103SetSlot extends Packet
     }
 
     @Override
-	public void writePacketData(DataOutputStream dos)
+	public void write(DataOutputStream dos)
         throws IOException
     {
         dos.writeByte(windowId);
@@ -67,7 +67,7 @@ public class Packet103SetSlot extends Packet
     }
 
     @Override
-	public int getPacketSize()
+	public int getEstimatedSize()
     {
         return 8;
     }
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet250CustomPayload.java b/src/main/java/net/minecraft/core/net/packet/CustomPayloadPacket.java
similarity index 62%
rename from src/main/java/net/minecraft/core/net/packet/Packet250CustomPayload.java
rename to src/main/java/net/minecraft/core/net/packet/CustomPayloadPacket.java
index 2884238ed..941706a31 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet250CustomPayload.java
+++ b/src/main/java/net/minecraft/core/net/packet/CustomPayloadPacket.java
@@ -4,18 +4,18 @@ import java.io.DataInputStream;
 import java.io.DataOutputStream;
 import java.io.IOException;
 
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 
-public class Packet250CustomPayload extends Packet {
+public class CustomPayloadPacket extends Packet {
 	
 	public String channel;
 	public byte[] data;
 	
-	public Packet250CustomPayload() {
+	public CustomPayloadPacket() {
 		
 	}
 	
-	public Packet250CustomPayload(String channel, byte[] data) {
+	public CustomPayloadPacket(String channel, byte[] data) {
 		this.channel = channel;
 		
 		if(data != null) {
@@ -27,7 +27,7 @@ public class Packet250CustomPayload extends Packet {
 	}
 	
 	@Override
-	public void readPacketData(DataInputStream in) throws IOException {
+	public void read(DataInputStream in) throws IOException {
 		this.channel = readString(in, 20);
 		int length = in.readInt();
 		
@@ -38,7 +38,7 @@ public class Packet250CustomPayload extends Packet {
 	}
 
 	@Override
-	public void writePacketData(DataOutputStream out) throws IOException {
+	public void write(DataOutputStream out) throws IOException {
 		writeString(channel, out);
 		if(data != null) {
 			out.writeInt(data.length);
@@ -49,12 +49,12 @@ public class Packet250CustomPayload extends Packet {
 	}
 
 	@Override
-	public void processPacket(NetHandler netHandler) {
-		netHandler.handleCustomPayload(this);
+	public void handlePacket(PacketHandler packetHandler) {
+		packetHandler.handleCustomPayload(this);
 	}
 
 	@Override
-	public int getPacketSize() {
+	public int getEstimatedSize() {
 		return channel.length() + 4 + data.length;
 	}
 
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet255KickDisconnect.java b/src/main/java/net/minecraft/core/net/packet/DisconnectPacket.java
similarity index 53%
rename from src/main/java/net/minecraft/core/net/packet/Packet255KickDisconnect.java
rename to src/main/java/net/minecraft/core/net/packet/DisconnectPacket.java
index a60b3b05f..17b81d8a5 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet255KickDisconnect.java
+++ b/src/main/java/net/minecraft/core/net/packet/DisconnectPacket.java
@@ -1,37 +1,36 @@
 package net.minecraft.core.net.packet;
 
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 
 import java.io.*;
-import java.nio.charset.StandardCharsets;
 
-public class Packet255KickDisconnect extends Packet
+public class DisconnectPacket extends Packet
 {
 
-    public Packet255KickDisconnect()
+    public DisconnectPacket()
     {
     }
 
-    public Packet255KickDisconnect(String s)
+    public DisconnectPacket(String s)
     {
         this(s, null);
     }
 
-    public Packet255KickDisconnect(String s, byte[] image)
+    public DisconnectPacket(String s, byte[] image)
     {
         reason = s;
         this.image = image;
     }
 
     @Override
-	public void readPacketData(DataInputStream dis)
+	public void read(DataInputStream dis)
         throws IOException
     {
         reason = readUTF16BEString(dis, 255);
     }
 
     @Override
-	public void writePacketData(DataOutputStream dos)
+	public void write(DataOutputStream dos)
         throws IOException
     {
         writeUTF16BEString(reason, dos);
@@ -42,13 +41,13 @@ public class Packet255KickDisconnect extends Packet
     }
 
     @Override
-	public void processPacket(NetHandler netHandler)
+	public void handlePacket(PacketHandler packetHandler)
     {
-        netHandler.handleKickDisconnect(this);
+        packetHandler.handleKickDisconnect(this);
     }
 
     @Override
-	public int getPacketSize()
+	public int getEstimatedSize()
     {
         return reason.length();
     }
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet38EntityStatus.java b/src/main/java/net/minecraft/core/net/packet/EnitityEventPacket.java
similarity index 61%
rename from src/main/java/net/minecraft/core/net/packet/Packet38EntityStatus.java
rename to src/main/java/net/minecraft/core/net/packet/EnitityEventPacket.java
index b617cd9a8..ec4b04a19 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet38EntityStatus.java
+++ b/src/main/java/net/minecraft/core/net/packet/EnitityEventPacket.java
@@ -1,27 +1,27 @@
 package net.minecraft.core.net.packet;
 
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 
 import java.io.*;
 
 // Referenced classes of package net.minecraft.src:
-//            Packet, NetHandler
+//            Packet, PacketHandler
 
-public class Packet38EntityStatus extends Packet
+public class EnitityEventPacket extends Packet
 {
 
-    public Packet38EntityStatus()
+    public EnitityEventPacket()
     {
     }
     
-    public Packet38EntityStatus(int entityId, byte entityStatus)
+    public EnitityEventPacket(int entityId, byte entityStatus)
     {
         this.entityId = entityId;
         this.entityStatus = entityStatus;
         attackedAtYaw = 0;
     }
 
-    public Packet38EntityStatus(int entityId, byte entityStatus, float attackedAtYaw)
+    public EnitityEventPacket(int entityId, byte entityStatus, float attackedAtYaw)
     {
         this.entityId = entityId;
         this.entityStatus = entityStatus;
@@ -29,7 +29,7 @@ public class Packet38EntityStatus extends Packet
     }
 
     @Override
-	public void readPacketData(DataInputStream dis)
+	public void read(DataInputStream dis)
         throws IOException
     {
         entityId = dis.readInt();
@@ -38,7 +38,7 @@ public class Packet38EntityStatus extends Packet
     }
 
     @Override
-	public void writePacketData(DataOutputStream dos)
+	public void write(DataOutputStream dos)
         throws IOException
     {
         dos.writeInt(entityId);
@@ -47,13 +47,13 @@ public class Packet38EntityStatus extends Packet
     }
 
     @Override
-	public void processPacket(NetHandler netHandler)
+	public void handlePacket(PacketHandler packetHandler)
     {
-        netHandler.handleEntityStatus(this);
+        packetHandler.handleEntityStatus(this);
     }
 
     @Override
-	public int getPacketSize()
+	public int getEstimatedSize()
     {
         return 9;
     }
diff --git a/src/main/java/net/minecraft/core/net/packet/EntityNicknamePacket.java b/src/main/java/net/minecraft/core/net/packet/EntityNicknamePacket.java
new file mode 100644
index 000000000..659b3906c
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/packet/EntityNicknamePacket.java
@@ -0,0 +1,49 @@
+package net.minecraft.core.net.packet;
+
+import net.minecraft.core.net.handler.PacketHandler;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+
+public class EntityNicknamePacket extends Packet
+{
+    public int entityId;
+    public String nickname;
+    public byte chatColor;
+    public EntityNicknamePacket()
+    {
+    }
+
+    public EntityNicknamePacket(int entityId, String nickname, byte chatColor)
+    {
+        this.entityId = entityId;
+        this.nickname = nickname;
+        this.chatColor = chatColor;
+    }
+
+    @Override
+    public int getEstimatedSize()
+    {
+        return 4 + nickname.length() + 1;
+    }
+
+    @Override
+    public void read(DataInputStream dis) throws IOException
+    {
+        nickname = readString(dis, 32);
+        chatColor = dis.readByte();
+    }
+
+    @Override
+    public void write(DataOutputStream dos) throws IOException
+    {
+        writeString(nickname, dos);
+        dos.writeByte(chatColor);
+    }
+
+    @Override
+    public void handlePacket(PacketHandler packetHandler) {
+        packetHandler.handleEntityNickname(this);
+    }
+}
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet42EntityTagData.java b/src/main/java/net/minecraft/core/net/packet/EntityTagDataPacket.java
similarity index 60%
rename from src/main/java/net/minecraft/core/net/packet/Packet42EntityTagData.java
rename to src/main/java/net/minecraft/core/net/packet/EntityTagDataPacket.java
index be43a397e..a871bc41a 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet42EntityTagData.java
+++ b/src/main/java/net/minecraft/core/net/packet/EntityTagDataPacket.java
@@ -2,21 +2,21 @@ package net.minecraft.core.net.packet;
 
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 
 import java.io.DataInputStream;
 import java.io.DataOutputStream;
 import java.io.IOException;
 
-public class Packet42EntityTagData extends Packet {
+public class EntityTagDataPacket extends Packet {
     public int entityId;
     public CompoundTag tag;
 
-    public Packet42EntityTagData() {
+    public EntityTagDataPacket() {
         super();
     }
 
-    public Packet42EntityTagData(Entity entity) {
+    public EntityTagDataPacket(Entity entity) {
         super();
         this.entityId = entity.id;
         this.tag = new CompoundTag();
@@ -24,24 +24,24 @@ public class Packet42EntityTagData extends Packet {
     }
 
     @Override
-    public void readPacketData(DataInputStream dis) throws IOException {
+    public void read(DataInputStream dis) throws IOException {
         this.entityId = dis.readInt();
         this.tag = Packet.readCompressedCompoundTag(dis);
     }
 
     @Override
-    public void writePacketData(DataOutputStream dos) throws IOException {
+    public void write(DataOutputStream dos) throws IOException {
         dos.writeInt(this.entityId);
         Packet.writeCompressedCompoundTag(this.tag, dos);
     }
 
     @Override
-    public void processPacket(NetHandler netHandler) {
-        netHandler.handleEntityTagData(this);
+    public void handlePacket(PacketHandler packetHandler) {
+        packetHandler.handleEntityTagData(this);
     }
 
     @Override
-    public int getPacketSize() {
+    public int getEstimatedSize() {
         return 0;
     }
 }
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet60Explosion.java b/src/main/java/net/minecraft/core/net/packet/ExplosionPacket.java
similarity index 79%
rename from src/main/java/net/minecraft/core/net/packet/Packet60Explosion.java
rename to src/main/java/net/minecraft/core/net/packet/ExplosionPacket.java
index 73844ba60..53d990e94 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet60Explosion.java
+++ b/src/main/java/net/minecraft/core/net/packet/ExplosionPacket.java
@@ -1,12 +1,12 @@
 package net.minecraft.core.net.packet;
 
 import net.minecraft.core.world.chunk.ChunkPosition;
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 
 import java.io.*;
 import java.util.*;
 
-public class Packet60Explosion extends Packet
+public class ExplosionPacket extends Packet
 {
 
     public double explosionX;
@@ -16,11 +16,11 @@ public class Packet60Explosion extends Packet
     public Set<ChunkPosition> destroyedBlockPositions;
     public boolean isCannonball;
 
-    public Packet60Explosion()
+    public ExplosionPacket()
     {
     }
 
-    public Packet60Explosion(double d, double d1, double d2, float f, Set<ChunkPosition> set, boolean isCannonball)
+    public ExplosionPacket(double d, double d1, double d2, float f, Set<ChunkPosition> set, boolean isCannonball)
     {
         explosionX = d;
         explosionY = d1;
@@ -31,7 +31,7 @@ public class Packet60Explosion extends Packet
     }
 
     @Override
-	public void readPacketData(DataInputStream dis) throws IOException
+	public void read(DataInputStream dis) throws IOException
     {
         explosionX = dis.readDouble();
         explosionY = dis.readDouble();
@@ -54,7 +54,7 @@ public class Packet60Explosion extends Packet
     }
 
     @Override
-	public void writePacketData(DataOutputStream dos) throws IOException
+	public void write(DataOutputStream dos) throws IOException
     {
         dos.writeDouble(explosionX);
         dos.writeDouble(explosionY);
@@ -75,13 +75,13 @@ public class Packet60Explosion extends Packet
     }
 
     @Override
-	public void processPacket(NetHandler netHandler)
+	public void handlePacket(PacketHandler packetHandler)
     {
-        netHandler.handleExplosion(this);
+        packetHandler.handleExplosion(this);
     }
 
     @Override
-	public int getPacketSize()
+	public int getEstimatedSize()
     {
         return 32 + (destroyedBlockPositions.size() * 3) + 1;
     }
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet142OpenFlagWindow.java b/src/main/java/net/minecraft/core/net/packet/FlagOpenPacket.java
similarity index 63%
rename from src/main/java/net/minecraft/core/net/packet/Packet142OpenFlagWindow.java
rename to src/main/java/net/minecraft/core/net/packet/FlagOpenPacket.java
index c613f1d18..8797f400f 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet142OpenFlagWindow.java
+++ b/src/main/java/net/minecraft/core/net/packet/FlagOpenPacket.java
@@ -1,12 +1,12 @@
 package net.minecraft.core.net.packet;
 
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 
 import java.io.DataInputStream;
 import java.io.DataOutputStream;
 import java.io.IOException;
 
-public class Packet142OpenFlagWindow
+public class FlagOpenPacket
     extends Packet
 {
     public int windowId;
@@ -14,9 +14,9 @@ public class Packet142OpenFlagWindow
     public int y;
     public int z;
 
-    public Packet142OpenFlagWindow() { }
+    public FlagOpenPacket() { }
 
-    public Packet142OpenFlagWindow(int windowId, int x, int y, int z)
+    public FlagOpenPacket(int windowId, int x, int y, int z)
     {
         this.windowId = windowId;
         this.x = x;
@@ -25,7 +25,7 @@ public class Packet142OpenFlagWindow
     }
 
     @Override
-    public void readPacketData(DataInputStream dis)
+    public void read(DataInputStream dis)
             throws IOException
     {
         windowId = dis.readByte();
@@ -35,7 +35,7 @@ public class Packet142OpenFlagWindow
     }
 
     @Override
-    public void writePacketData(DataOutputStream dos)
+    public void write(DataOutputStream dos)
             throws IOException
     {
         dos.writeByte(windowId);
@@ -45,13 +45,13 @@ public class Packet142OpenFlagWindow
     }
 
     @Override
-    public void processPacket(NetHandler netHandler)
+    public void handlePacket(PacketHandler packetHandler)
     {
-        netHandler.handleOpenFlagWindow(this);
+        packetHandler.handleOpenFlagWindow(this);
     }
 
     @Override
-    public int getPacketSize()
+    public int getEstimatedSize()
     {
         return 1 + 4 + 2 + 4;
     }
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet74GameRule.java b/src/main/java/net/minecraft/core/net/packet/GameRulePacket.java
similarity index 64%
rename from src/main/java/net/minecraft/core/net/packet/Packet74GameRule.java
rename to src/main/java/net/minecraft/core/net/packet/GameRulePacket.java
index ef7e72bb0..ce75056b2 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet74GameRule.java
+++ b/src/main/java/net/minecraft/core/net/packet/GameRulePacket.java
@@ -7,17 +7,17 @@ import java.io.IOException;
 import com.mojang.nbt.CompoundTag;
 
 import net.minecraft.core.data.gamerule.GameRuleCollection;
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 
-public class Packet74GameRule
+public class GameRulePacket
     extends Packet {
     private GameRuleCollection gameRules;
 
-    public Packet74GameRule() {
+    public GameRulePacket() {
         gameRules = null;
     }
 
-    public Packet74GameRule(GameRuleCollection gameRules) {
+    public GameRulePacket(GameRuleCollection gameRules) {
         this.gameRules = gameRules;
     }
 
@@ -26,25 +26,25 @@ public class Packet74GameRule
     }
 
     @Override
-    public void readPacketData(DataInputStream dis) throws IOException {
+    public void read(DataInputStream dis) throws IOException {
         CompoundTag tag = readCompressedCompoundTag(dis);
         gameRules = GameRuleCollection.readFromNBT(tag);
     }
 
     @Override
-    public void writePacketData(DataOutputStream dos) throws IOException {
+    public void write(DataOutputStream dos) throws IOException {
         CompoundTag tag = new CompoundTag();
         GameRuleCollection.writeToNBT(tag, gameRules);
         writeCompressedCompoundTag(tag, dos);
     }
 
     @Override
-    public void processPacket(NetHandler netHandler) {
-        netHandler.handleGameRule(this);
+    public void handlePacket(PacketHandler packetHandler) {
+        packetHandler.handleGameRule(this);
     }
 
     @Override
-    public int getPacketSize() {
+    public int getEstimatedSize() {
         return 0;
     }
 }
diff --git a/src/main/java/net/minecraft/core/net/packet/Packet133OpenGuidebook.java b/src/main/java/net/minecraft/core/net/packet/GuidebookPacket.java
similarity index 55%
rename from src/main/java/net/minecraft/core/net/packet/Packet133OpenGuidebook.java
rename to src/main/java/net/minecraft/core/net/packet/GuidebookPacket.java
index 45f1e9d05..2550b69ef 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet133OpenGuidebook.java
+++ b/src/main/java/net/minecraft/core/net/packet/GuidebookPacket.java
@@ -1,44 +1,44 @@
 package net.minecraft.core.net.packet;
 
-import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.net.handler.PacketHandler;
 
 import java.io.DataInputStream;
 import java.io.DataOutputStream;
 import java.io.IOException;
 
-public class Packet133OpenGuidebook extends Packet{
+public class GuidebookPacket extends Packet{
 
-    public Packet133OpenGuidebook()
+    public GuidebookPacket()
     {
     }
 
-    public Packet133OpenGuidebook(boolean i)
+    public GuidebookPacket(boolean i)
     {
         isGuidebookOpen = i;
     }
 
     @Override
-	public void readPacketData(DataInputStream dis)
+	public void read(DataInputStream dis)
             throws IOException
     {
         isGuidebookOpen = dis.readBoolean();
     }
 
     @Override
-	public void writePacketData(DataOutputStream dos)
+	public void write(DataOutputStream dos)
             throws IOException
     {
         dos.writeBoolean(isGuidebookOpen);
     }
 
     @Override
-	public void processPacket(NetHandler netHandler)
+	public void handlePacket(PacketHandler packetHandler)
     {
-        netHandler.handleOpenGuidebook(this);
+        packetHandler.handleOpenGuidebook(this);
     }
 
     @Override
-	public int getPacketSize()
+	public int getEstimatedSize()
     {
         return 1;
     }
diff --git a/src/main/java/net/minecraft/core/net/packet/InteractPacket.java b/src/main/java/net/minecraft/core/net/packet/InteractPacket.java
new file mode 100644
index 000000000..03bb57665
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/packet/InteractPacket.java
@@ -0,0 +1,59 @@
+package net.minecraft.core.net.packet;
+
+import net.minecraft.core.net.handler.PacketHandler;
+
+import java.io.*;
+
+// Referenced classes of package net.minecraft.src:
+//            Packet, PacketHandler
+
+public class InteractPacket extends Packet
+{
+    public static final int ACTION_INTERACT = 0;
+    public static final int ACTION_ATTACK = 1;
+    public int sourceEntityID;
+    public int targetEntityID;
+    public int action;
+
+
+    public InteractPacket()
+    {
+    }
+
+    public InteractPacket(int source, int target, int action)
+    {
+        sourceEntityID = source;
+        targetEntityID = target;
+        this.action = action;
+    }
+
+    @Override
+	public void read(DataInputStream dis)
+        throws IOException
+    {
+        sourceEntityID = dis.readInt();
+        targetEntityID = dis.readInt();
+        action = dis.readByte();
+    }
+
+    @Override
+	public void write(DataOutputStream dos)
+        throws IOException
+    {
+        dos.writeInt(sourceEntityID);
+        dos.writeInt(targetEntityID);
+        dos.writeByte(action);
+    }
+
+    @Override
+	public void handlePacket(PacketHandler packetHandler)
+    {
+        packetHandler.handleUseEntity(this);
+    }
+
+    @Override
+	public int getEstimatedSize()
+    {
+        return 9;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/packet/KeepAlivePacket.java b/src/main/java/net/minecraft/core/net/packet/KeepAlivePacket.java
new file mode 100644
index 000000000..449891ac5
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/packet/KeepAlivePacket.java
@@ -0,0 +1,39 @@
+package net.minecraft.core.net.packet;
+
+import net.minecraft.core.net.handler.PacketHandler;
+
+import java.io.*;
+
+// Referenced classes of package net.minecraft.src:
+//            Packet, PacketHandler
+
+public class KeepAlivePacket extends Packet
+{
+
+    public KeepAlivePacket()
+    {
+    }
+
+    @Override
+	public void handlePacket(PacketHandler packetHandler)
+    {
+    }
+
+    @Override
+	public void read(DataInputStream dis)
+        throws IOException
+    {
+    }
+
+    @Override
+	public void write(DataOutputStream dos)
+        throws IOException
+    {
+    }
+
+    @Override
+	public int getEstimatedSize()
+    {
+        return 0;
+    }
+}
